﻿Imports System.Text.RegularExpressions


Public Class TestForm

    Private Sub PView_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PView.MouseLeave
        If _LinkIndex <> -1 Then
            _LinkIndex = -1
            PView.Cursor = Cursors.Default
            PView.Invalidate()
            Exit Sub
        End If
    End Sub

    Private Sub PView_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PView.MouseMove
        For i As Integer = 0 To _Links.Length - 1
            If _Links(i).PointOnRegion(e.Location) Then
                If _LinkIndex <> i Then
                    _LinkIndex = i
                    PView.Cursor = Cursors.Hand
                    PView.Invalidate()
                End If
                Exit Sub
            End If
        Next
        If _LinkIndex <> -1 Then
            _LinkIndex = -1
            PView.Cursor = Cursors.Default
            PView.Invalidate()
            Exit Sub
        End If
    End Sub

    Private Sub PView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PView.MouseUp
        For i As Integer = 0 To _Links.Length - 1
            If _Links(i).PointOnRegion(e.Location) Then
                MsgBox(_Links(i).LinkContent, MsgBoxStyle.Information, "Клик по ссылке")
                _LinkIndex = i
                Exit Sub
            End If
        Next
    End Sub

    Private Sub PView_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PView.Paint
        'Строка
        Dim TestString As String 
        TestString = txtTest.Text
        'Шрифт
        Dim DrawFont As Font = FontText.Font

        'Рабочая область
        Dim LayoutArea As New RectangleF(5, 5, PView.ClientRectangle.Width - 10, PView.ClientRectangle.Height - 10)

        'Настройка позиций блоков текста
        Dim ChrRngs(0) As CharacterRange
        ChrRngs(ChrRngs.Length - 1).First = 0

        ReDim _Links(-1)

        'Выдергиваем ссылки
        Try
            Dim RegexObj As New Regex("\b(https?|ftp|file)://[-A-Z0-9+&@#/%?=~_|!:,.;]*[-A-Z0-9+&@#/%=~_|]", RegexOptions.IgnoreCase)
            Dim MatchResults As Match = RegexObj.Match(TestString)
            While MatchResults.Success
                'Закончил блок
                ChrRngs(ChrRngs.Length - 1).Length = MatchResults.Index - ChrRngs(ChrRngs.Length - 1).First

                'Добовляем новый
                ReDim Preserve ChrRngs(ChrRngs.Length)
                ChrRngs(ChrRngs.Length - 1).First = MatchResults.Index
                ChrRngs(ChrRngs.Length - 1).Length = MatchResults.Length
                ReDim Preserve _Links(_Links.Length)
                _Links(_Links.Length - 1) = New SLinksInfo(MatchResults.Value)

                'Начинаем  новый
                ReDim Preserve ChrRngs(ChrRngs.Length)
                ChrRngs(ChrRngs.Length - 1).First = MatchResults.Index + MatchResults.Length
                MatchResults = MatchResults.NextMatch()
            End While
        Catch ex As ArgumentException
        End Try
        'Заканчиваем последний
        ChrRngs(ChrRngs.Length - 1).Length = TestString.Length - ChrRngs(ChrRngs.Length - 1).First

        'Настройка формата вывод
        Dim StrFrm As StringFormat = StringFormat.GenericTypographic
        StrFrm.FormatFlags = StringFormatFlags.NoClip Or StringFormatFlags.MeasureTrailingSpaces
        StrFrm.Trimming = StringTrimming.Character
        StrFrm.SetMeasurableCharacterRanges(ChrRngs)

        'Выводим
        With e.Graphics
            .TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
            Dim i = 0, j = 0, Count As Integer = 0
            Dim Rects() As RectangleF
            Dim TextRegions() As Region = .MeasureCharacterRanges(TestString, DrawFont, LayoutArea, StrFrm)
            Dim TextBrush As Brush = New SolidBrush(Color.Black)
            Dim LinkInd As Integer = 0
            For j = 1 To TextRegions.Length
                Rects = TextRegions(j - 1).GetRegionScans(New Drawing2D.Matrix)
                If j Mod 2 = 0 Then
                    If LinkInd = _LinkIndex Then
                        TextBrush = New SolidBrush(ColorLinkHover.Color)
                    Else
                        TextBrush = New SolidBrush(ColorLinkNormal.Color)
                    End If
                    _Links(LinkInd).LinkRegion = TextRegions(j - 1)
                    LinkInd += 1
                Else
                    TextBrush = New SolidBrush(ColorText.Color)
                End If
                For i = 0 To Rects.Length - 1
                    Rects(i).Width += 1
                    .MeasureString(TestString, DrawFont, Rects(i).Size, StrFrm, Count, Nothing)

                    .DrawString(Strings.Left(TestString, Count), DrawFont, TextBrush, Rects(i), StrFrm)
                    TestString = TestString.Substring(Count)
                Next
            Next
        End With
    End Sub

    Private Sub PView_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles PView.Resize
        PView.Invalidate()
    End Sub

    Private Structure SLinksInfo
        Public LinkRegion As Region
        Public LinkContent As String

        Public Sub New(ByVal Link As String)
            LinkContent = Link
            LinkRegion = New Region()
        End Sub

        Public Function PointOnRegion(ByVal P As Point) As Boolean
            Dim rs() As RectangleF = LinkRegion.GetRegionScans(New Drawing2D.Matrix)
            For i As Integer = 0 To rs.Length - 1
                If rs(i).Contains(P) Then Return True
            Next
            Return False
        End Function
    End Structure

    Private _Links(-1) As SLinksInfo
    Private _LinkIndex As Integer = -1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FontText.ShowDialog()
        PView.Invalidate()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ColorBG.ShowDialog()
        PView.BackColor = ColorBG.Color
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ColorText.ShowDialog()
        PView.Invalidate()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ColorLinkNormal.ShowDialog()
        PView.Invalidate()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        ColorLinkHover.ShowDialog()
        PView.Invalidate()
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTest.TextChanged
        PView.Invalidate()
    End Sub
End Class